searchNodes=[{"ref":"ExGcloudPubsubPuller.html","title":"ExGcloudPubsubPuller","type":"module","doc":"Documentation for ExGcloudPubsubPuller."},{"ref":"ExGcloudPubsubPuller.html#hello/0","title":"ExGcloudPubsubPuller.hello/0","type":"function","doc":"Hello world. Examples iex&gt; ExGcloudPubsubPuller.hello() :world"},{"ref":"ExGcloudPubsubPuller.PullController.html","title":"ExGcloudPubsubPuller.PullController","type":"behaviour","doc":"Implement the behaviour from this module to control pulling from a subscription. Add your controller to the config to ensure it gets run. Examples # config/config.exs: config :my_app, ExGcloudPubsubPuller.Scheduler, schedule: {:extended, &quot;*/5&quot;}, overlap: false, timezone: :utc, jobs: [ cost_job: [ task: {ExGcloudPubsubPuller, :main, [CostPullController]} ], usage_job: [ task: {ExGcloudPubsubPuller, :main, [UsagePullController]} ] ] # lib/my_app/cost_pull_controller.ex: defmodule CostPullController do @behaviour ExGcloudPubsubPuller.PullController @impl true def subscription_id(), do: &quot;cost-subscription&quot; @impl true def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: nil}), do: :error def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: data}) do IO.inspect(data) :ok end @impl true def handle_stagnant() do some_function_that_fixes_the_world() end @impl true def handle_pull_error(%Tesla.Env{status: 404}), do: IO.inspect(&quot;subscription doesn&#39;t exist!&quot;) def handle_pull_error(%Tesla.Env{status: 403}), do: IO.inspect(&quot;I am not authorized!&quot;) def handle_pull_error(%Tesla.Env{} = error), do: IO.inspect(&quot;Something went wrong: \#{inspect(error)}&quot;) end # lib/my_app/usage_pull_controller.ex: defmodule UsagePullController do @behaviour ExGcloudPubsubPuller.PullController @impl true def subscription_id(), do: &quot;usage-subscription&quot; @impl true def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: nil}), do: :error def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: data}) do IO.inspect(data) :ok end @impl true def handle_stagnant() do some_function_that_fixes_the_world() end @impl true def handle_pull_error(%Tesla.Env{status: 404}), do: IO.inspect(&quot;subscription doesn&#39;t exist!&quot;) def handle_pull_error(%Tesla.Env{status: 403}), do: IO.inspect(&quot;I am not authorized!&quot;) def handle_pull_error(%Tesla.Env{} = error), do: IO.inspect(&quot;Something went wrong: \#{inspect(error)}&quot;) end"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:handle_message/1","title":"ExGcloudPubsubPuller.PullController.handle_message/1","type":"callback","doc":"Gets called with each message that gets pulled from the subscription. Should return either :ok or :error. If :ok is returned, the message will be acknowledged. If :error is returned, the message will NOT be acknowledged. Examples @impl true def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: nil}), do: :error def handle_message(%GoogleApi.PubSub.V1.Model.PubsubMessage{data: data}) do IO.inspect(data) :ok end"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:handle_pull_error/1","title":"ExGcloudPubsubPuller.PullController.handle_pull_error/1","type":"callback","doc":"Gets called if pulling from Google PubSub yields an error. Examples @impl true def handle_pull_error(%Tesla.Env{status: 404}), do: IO.inspect(&quot;subscription doesn&#39;t exist!&quot;) def handle_pull_error(%Tesla.Env{status: 403}), do: IO.inspect(&quot;I am not authorized!&quot;) def handle_pull_error(%Tesla.Env{} = error), do: IO.inspect(&quot;Something went wrong: \#{inspect(error)}&quot;)"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:handle_stagnant/0","title":"ExGcloudPubsubPuller.PullController.handle_stagnant/0","type":"callback","doc":"Gets called if no message has come through the subscription in 30 seconds. Examples @impl true def handle_stagnant() do some_function_that_fixes_the_world() end"},{"ref":"ExGcloudPubsubPuller.PullController.html#c:subscription_id/0","title":"ExGcloudPubsubPuller.PullController.subscription_id/0","type":"callback","doc":"Should return the Google PubSub subscription id from which messages will be pulled. Gets called at the start of each job run. Examples @impl true def subscription_id(), do: &quot;my-super-good-subscription&quot;"}]